Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision 7a35204af3ba37f846d0edcb5cab455f0d70333c)
+++ boot/arch/amd64/Makefile.inc	(revision 619e7c9b0af31177bf441bbb64d080b4ba93bd4a)
@@ -72,11 +72,11 @@
 	done
 ifeq ($(RDFMT),tmpfs)
-	$(BASE)/tools/mktmpfs.py $(USPACEDIR)/dist/ arch/$(ARCH)/iso/boot/initrd.fs.img
+	$(BASE)/tools/mktmpfs.py $(USPACEDIR)/dist/ arch/$(ARCH)/iso/boot/initrd.fs
 endif
 ifeq ($(RDFMT),fat)
-	$(BASE)/tools/mkfat.sh $(USPACEDIR)/dist/ arch/$(ARCH)/iso/boot/initrd.fs.img
+	$(BASE)/tools/mkfat.sh $(USPACEDIR)/dist/ arch/$(ARCH)/iso/boot/initrd.fs
 endif
-	$(BASE)/tools/mkhord.py 4096 arch/$(ARCH)/iso/boot/initrd.fs.img arch/$(ARCH)/iso/boot/initrd.img
-	rm arch/$(ARCH)/iso/boot/initrd.fs.img
+	$(BASE)/tools/mkhord.py 4096 arch/$(ARCH)/iso/boot/initrd.fs arch/$(ARCH)/iso/boot/initrd.img
+	rm arch/$(ARCH)/iso/boot/initrd.fs
 	mkisofs -J -r -b boot/grub/stage2_eltorito -no-emul-boot -boot-load-size 4 -boot-info-table -o $(BASE)/image.iso arch/$(ARCH)/iso/
 
Index: boot/arch/arm32/loader/Makefile
===================================================================
--- boot/arch/arm32/loader/Makefile	(revision 7a35204af3ba37f846d0edcb5cab455f0d70333c)
+++ boot/arch/arm32/loader/Makefile	(revision 619e7c9b0af31177bf441bbb64d080b4ba93bd4a)
@@ -123,7 +123,7 @@
 		cp $$task $(USPACEDIR)/dist/sbin/ ; \
 	done
-	../../../../tools/mktmpfs.py $(USPACEDIR)/dist/ initrd.fs.img
-	../../../../tools/mkhord.py 4096 initrd.fs.img initrd.img
-	rm initrd.fs.img
+	../../../../tools/mktmpfs.py $(USPACEDIR)/dist/ initrd.fs
+	../../../../tools/mkhord.py 4096 initrd.fs initrd.img
+	rm initrd.fs
 	../../../tools/pack.py $(OBJCOPY) $(BFD_NAME) $(BFD_ARCH) 4096 "unsigned int" $(COMPONENTS) ./initrd.img
 
Index: boot/arch/ia32/Makefile.inc
===================================================================
--- boot/arch/ia32/Makefile.inc	(revision 7a35204af3ba37f846d0edcb5cab455f0d70333c)
+++ boot/arch/ia32/Makefile.inc	(revision 619e7c9b0af31177bf441bbb64d080b4ba93bd4a)
@@ -60,7 +60,7 @@
 		cp $$task $(USPACEDIR)/dist/sbin/ ; \
 	done
-	$(BASE)/tools/mktmpfs.py $(USPACEDIR)/dist/ arch/$(ARCH)/iso/boot/initrd.fs.img
-	$(BASE)/tools/mkhord.py 4096 arch/$(ARCH)/iso/boot/initrd.fs.img arch/$(ARCH)/iso/boot/initrd.img
-	rm arch/$(ARCH)/iso/boot/initrd.fs.img
+	$(BASE)/tools/mktmpfs.py $(USPACEDIR)/dist/ arch/$(ARCH)/iso/boot/initrd.fs
+	$(BASE)/tools/mkhord.py 4096 arch/$(ARCH)/iso/boot/initrd.fs arch/$(ARCH)/iso/boot/initrd.img
+	rm arch/$(ARCH)/iso/boot/initrd.fs
 	mkisofs -J -r -b boot/grub/stage2_eltorito -no-emul-boot -boot-load-size 4 -boot-info-table -o $(BASE)/image.iso arch/$(ARCH)/iso/
 
Index: boot/arch/mips32/loader/Makefile
===================================================================
--- boot/arch/mips32/loader/Makefile	(revision 7a35204af3ba37f846d0edcb5cab455f0d70333c)
+++ boot/arch/mips32/loader/Makefile	(revision 619e7c9b0af31177bf441bbb64d080b4ba93bd4a)
@@ -124,7 +124,7 @@
 		cp $$task $(USPACEDIR)/dist/sbin/ ; \
 	done
-	../../../../tools/mktmpfs.py $(USPACEDIR)/dist/ initrd.fs.img
-	../../../../tools/mkhord.py 16384 initrd.fs.img initrd.img
-	rm initrd.fs.img
+	../../../../tools/mktmpfs.py $(USPACEDIR)/dist/ initrd.fs
+	../../../../tools/mkhord.py 16384 initrd.fs initrd.img
+	rm initrd.fs
 	../../../tools/pack.py $(OBJCOPY) $(BFD_NAME) $(BFD_ARCH) 16384 "unsigned int" $(COMPONENTS) ./initrd.img
 
Index: boot/arch/ppc32/loader/Makefile
===================================================================
--- boot/arch/ppc32/loader/Makefile	(revision 7a35204af3ba37f846d0edcb5cab455f0d70333c)
+++ boot/arch/ppc32/loader/Makefile	(revision 619e7c9b0af31177bf441bbb64d080b4ba93bd4a)
@@ -118,7 +118,7 @@
 		cp $$task $(USPACEDIR)/dist/sbin/ ; \
 	done
-	../../../../tools/mktmpfs.py $(USPACEDIR)/dist/ initrd.fs.img
-	../../../../tools/mkhord.py 4096 initrd.fs.img initrd.img
-	rm initrd.fs.img
+	../../../../tools/mktmpfs.py $(USPACEDIR)/dist/ initrd.fs
+	../../../../tools/mkhord.py 4096 initrd.fs initrd.img
+	rm initrd.fs
 	../../../tools/pack.py $(OBJCOPY) $(BFD_NAME) $(BFD_ARCH) 4096 "unsigned int" $(COMPONENTS) ./initrd.img
 
Index: boot/arch/sparc64/loader/Makefile
===================================================================
--- boot/arch/sparc64/loader/Makefile	(revision 7a35204af3ba37f846d0edcb5cab455f0d70333c)
+++ boot/arch/sparc64/loader/Makefile	(revision 619e7c9b0af31177bf441bbb64d080b4ba93bd4a)
@@ -121,7 +121,7 @@
 		cp $$task $(USPACEDIR)/dist/sbin/ ; \
 	done
-	../../../../tools/mktmpfs.py $(USPACEDIR)/dist/ initrd.fs.img
-	../../../../tools/mkhord.py 16384 initrd.fs.img initrd.img
-	rm initrd.fs.img
+	../../../../tools/mktmpfs.py $(USPACEDIR)/dist/ initrd.fs
+	../../../../tools/mkhord.py 16384 initrd.fs initrd.img
+	rm initrd.fs
 	../../../tools/pack.py $(OBJCOPY) $(BFD_NAME) $(BFD_ARCH) 1 "unsigned long" $(COMPONENTS) ./initrd.img
 