Index: uspace/app/tester/devmap/devmap1.c
===================================================================
--- uspace/app/tester/devmap/devmap1.c	(revision 5c786d177c5354b44d4e3fa8f52182f680d515c1)
+++ uspace/app/tester/devmap/devmap1.c	(revision 654b7dbfd1ebbe9e1b89c799d0698fa6cc06de69)
@@ -50,6 +50,7 @@
 	int retval;
 	
-	printf("connected: method=%u arg1=%u, arg2=%u arg3=%u.\n", IPC_GET_METHOD(*icall), 
-		IPC_GET_ARG1(*icall), IPC_GET_ARG2(*icall), IPC_GET_ARG3(*icall));
+	printf("connected: method=%u arg1=%u, arg2=%u arg3=%u.\n",
+	    IPC_GET_METHOD(*icall), IPC_GET_ARG1(*icall), IPC_GET_ARG2(*icall),
+	    IPC_GET_ARG3(*icall));
 
 	printf("driver_client_connection.\n");
@@ -60,6 +61,7 @@
 		callid = async_get_call(&call);
 		retval = EOK;
-		printf("method=%u arg1=%u, arg2=%u arg3=%u.\n", IPC_GET_METHOD(call), 
-			IPC_GET_ARG1(call), IPC_GET_ARG2(call), IPC_GET_ARG3(call));
+		printf("method=%u arg1=%u, arg2=%u arg3=%u.\n",
+		    IPC_GET_METHOD(call), IPC_GET_ARG1(call),
+		    IPC_GET_ARG2(call), IPC_GET_ARG3(call));
 		switch (IPC_GET_METHOD(call)) {
 		case IPC_M_PHONE_HUNGUP:
@@ -67,5 +69,6 @@
 			return;
 		default:
-			printf("Unknown device method %u.\n", IPC_GET_METHOD(call));
+			printf("Unknown device method %u.\n",
+			    IPC_GET_METHOD(call));
 			retval = ENOENT;
 		}
@@ -82,10 +85,10 @@
 	handle = (int)arg;
 
-	device_phone = ipc_connect_me_to(PHONE_NS, SERVICE_DEVMAP, \
-		DEVMAP_CONNECT_TO_DEVICE, handle);
+	device_phone = ipc_connect_me_to(PHONE_NS, SERVICE_DEVMAP,
+	    DEVMAP_CONNECT_TO_DEVICE, handle);
 
 	if (device_phone < 0) {
-		printf("Failed to connect to devmap as client (handle = %u).\n", 
-			handle);
+		printf("Failed to connect to devmap as client (handle = %u).\n",
+		    handle);
 		return -1;
 	}
@@ -130,16 +133,15 @@
 	ipcarg_t callback_phonehash;
 
-	phone = ipc_connect_me_to(PHONE_NS, SERVICE_DEVMAP,
-		DEVMAP_DRIVER, 0);
+	phone = ipc_connect_me_to(PHONE_NS, SERVICE_DEVMAP, DEVMAP_DRIVER, 0);
 
 	while (phone < 0) {
 		usleep(100000);
 		phone = ipc_connect_me_to(PHONE_NS, SERVICE_DEVMAP,
-			DEVMAP_DRIVER, 0);
+		    DEVMAP_DRIVER, 0);
 	}
 	
 	req = async_send_2(phone, DEVMAP_DRIVER_REGISTER, 0, 0, &answer);
 
-	retval = ipc_data_send(phone, (char *)name, strlen(name) + 1); 
+	retval = ipc_data_write_send(phone, (char *)name, strlen(name) + 1); 
 
 	if (retval != EOK) {
@@ -171,7 +173,8 @@
 	ipc_call_t answer;
 
-	req = async_send_2(driver_phone, DEVMAP_DEVICE_GET_HANDLE, 0, 0, &answer);
-
-	retval = ipc_data_send(driver_phone, name, strlen(name) + 1); 
+	req = async_send_2(driver_phone, DEVMAP_DEVICE_GET_HANDLE, 0, 0,
+	    &answer);
+
+	retval = ipc_data_write_send(driver_phone, name, strlen(name) + 1); 
 
 	if (retval != EOK) {
@@ -192,5 +195,6 @@
 			*handle = (int) IPC_GET_ARG1(answer);
 		}
-		printf("Device '%s' has handle %u.\n", name, (int) IPC_GET_ARG1(answer));
+		printf("Device '%s' has handle %u.\n", name,
+		    (int) IPC_GET_ARG1(answer));
 	} else {
 		printf("Failed to get handle for device '%s'.\n", name);
@@ -213,5 +217,6 @@
 	req = async_send_2(driver_phone, DEVMAP_DEVICE_REGISTER, 0, 0, &answer);
 
-	retval = ipc_data_send(driver_phone, (char *)name, strlen(name) + 1); 
+	retval = ipc_data_write_send(driver_phone, (char *)name,
+	    strlen(name) + 1); 
 
 	if (retval != EOK) {
@@ -232,5 +237,6 @@
 			*handle = (int) IPC_GET_ARG1(answer);
 		}
-		printf("Device registered with handle %u.\n", (int) IPC_GET_ARG1(answer));
+		printf("Device registered with handle %u.\n",
+		    (int) IPC_GET_ARG1(answer));
 	}
 
Index: uspace/app/tester/vfs/vfs1.c
===================================================================
--- uspace/app/tester/vfs/vfs1.c	(revision 5c786d177c5354b44d4e3fa8f52182f680d515c1)
+++ uspace/app/tester/vfs/vfs1.c	(revision 654b7dbfd1ebbe9e1b89c799d0698fa6cc06de69)
@@ -54,9 +54,9 @@
 	aid_t req;
 	req = async_send_1(vfs_phone, VFS_MOUNT, TMPFS_DEVHANDLE, NULL);
-	if (ipc_data_send(vfs_phone, fs_name, strlen(fs_name)) != EOK) {
+	if (ipc_data_write_send(vfs_phone, fs_name, strlen(fs_name)) != EOK) {
 		async_wait_for(req, &rc);
 		return "Could not send fs_name to VFS.\n";
 	}
-	if (ipc_data_send(vfs_phone, mp, strlen(mp)) != EOK) {
+	if (ipc_data_write_send(vfs_phone, mp, strlen(mp)) != EOK) {
 		async_wait_for(req, &rc);
 		return "Could not send mp to VFS.\n";
@@ -71,5 +71,5 @@
 	ipc_call_t answer;
 	req = async_send_2(vfs_phone, VFS_OPEN, 0, 0, &answer);
-	if (ipc_data_send(vfs_phone, path, strlen(path)) != EOK) {
+	if (ipc_data_write_send(vfs_phone, path, strlen(path)) != EOK) {
 		async_wait_for(req, &rc);
 		return "Could not send path to VFS.\n";
Index: uspace/lib/libc/generic/ipc.c
===================================================================
--- uspace/lib/libc/generic/ipc.c	(revision 5c786d177c5354b44d4e3fa8f52182f680d515c1)
+++ uspace/lib/libc/generic/ipc.c	(revision 654b7dbfd1ebbe9e1b89c799d0698fa6cc06de69)
@@ -667,5 +667,5 @@
 }
 
-/** Wrapper for making IPC_M_DATA_SEND calls.
+/** Wrapper for making IPC_M_DATA_WRITE calls.
  *
  * @param phoneid	Phone that will be used to contact the receiving side.
@@ -675,18 +675,18 @@
  * @return		Zero on success or a negative error code from errno.h.
  */
-int ipc_data_send(int phoneid, void *src, size_t size)
-{
-	return ipc_call_sync_3_0(phoneid, IPC_M_DATA_SEND, 0, (ipcarg_t) src,
+int ipc_data_write_send(int phoneid, void *src, size_t size)
+{
+	return ipc_call_sync_3_0(phoneid, IPC_M_DATA_WRITE, 0, (ipcarg_t) src,
 	    (ipcarg_t) size);
 }
 
-/** Wrapper for receiving the IPC_M_DATA_SEND calls.
- *
- * This wrapper only makes it more comfortable to receive IPC_M_DATA_SEND calls
+/** Wrapper for receiving the IPC_M_DATA_WRITE calls.
+ *
+ * This wrapper only makes it more comfortable to receive IPC_M_DATA_WRITE calls
  * so that the user doesn't have to remember the meaning of each IPC argument.
  *
  * So far, this wrapper is to be used from within a connection fibril.
  *
- * @param callid	Storage where the hash of the IPC_M_DATA_SEND call will
+ * @param callid	Storage where the hash of the IPC_M_DATA_WRITE call will
  * 			be stored.
  * @param dst		Storage where the suggested destination address will
@@ -697,5 +697,5 @@
  * @return		Non-zero on success, zero on failure.
  */
-int ipc_data_receive(ipc_callid_t *callid, void **dst, size_t *size)
+int ipc_data_write_receive(ipc_callid_t *callid, void **dst, size_t *size)
 {
 	ipc_call_t data;
@@ -704,5 +704,5 @@
 
 	*callid = async_get_call(&data);
-	if (IPC_GET_METHOD(data) != IPC_M_DATA_SEND)
+	if (IPC_GET_METHOD(data) != IPC_M_DATA_WRITE)
 		return 0;
 	if (dst)
@@ -713,16 +713,16 @@
 }
 
-/** Wrapper for answering the IPC_M_DATA_SEND calls.
- *
- * This wrapper only makes it more comfortable to answer IPC_M_DATA_SEND calls
+/** Wrapper for answering the IPC_M_DATA_WRITE calls.
+ *
+ * This wrapper only makes it more comfortable to answer IPC_M_DATA_WRITE calls
  * so that the user doesn't have to remember the meaning of each IPC argument.
  *
- * @param callid	Hash of the IPC_M_DATA_SEND call to answer.
- * @param dst		Final destination address for the IPC_M_DATA_SEND call.
- * @param size		Final size for the IPC_M_DATA_SEND call.
+ * @param callid	Hash of the IPC_M_DATA_WRITE call to answer.
+ * @param dst		Final destination address for the IPC_M_DATA_WRITE call.
+ * @param size		Final size for the IPC_M_DATA_WRITE call.
  *
  * @return		Zero on success or a value from @ref errno.h on failure.
  */
-ipcarg_t ipc_data_deliver(ipc_callid_t callid, void *dst, size_t size)
+ipcarg_t ipc_data_write_deliver(ipc_callid_t callid, void *dst, size_t size)
 {
 	return ipc_answer_3(callid, EOK, (ipcarg_t) dst, 0, (ipcarg_t) size);
Index: uspace/lib/libc/include/ipc/ipc.h
===================================================================
--- uspace/lib/libc/include/ipc/ipc.h	(revision 5c786d177c5354b44d4e3fa8f52182f680d515c1)
+++ uspace/lib/libc/include/ipc/ipc.h	(revision 654b7dbfd1ebbe9e1b89c799d0698fa6cc06de69)
@@ -261,7 +261,9 @@
 extern int ipc_forward_fast(ipc_callid_t callid, int phoneid, int method,
     ipcarg_t arg1, ipcarg_t arg2, int mode);
-extern int ipc_data_send(int phoneid, void *src, size_t size);
-extern int ipc_data_receive(ipc_callid_t *callid, void **dst, size_t *size);
-extern ipcarg_t ipc_data_deliver(ipc_callid_t callid, void *dst, size_t size);
+extern int ipc_data_write_send(int phoneid, void *src, size_t size);
+extern int ipc_data_write_receive(ipc_callid_t *callid, void **dst,
+    size_t *size);
+extern ipcarg_t ipc_data_write_deliver(ipc_callid_t callid, void *dst,
+    size_t size);
 
 #endif
Index: uspace/lib/libfs/libfs.c
===================================================================
--- uspace/lib/libfs/libfs.c	(revision 5c786d177c5354b44d4e3fa8f52182f680d515c1)
+++ uspace/lib/libfs/libfs.c	(revision 654b7dbfd1ebbe9e1b89c799d0698fa6cc06de69)
@@ -72,5 +72,5 @@
 	 * Send our VFS info structure to VFS.
 	 */
-	int rc = ipc_data_send(vfs_phone, info, sizeof(*info)); 
+	int rc = ipc_data_write_send(vfs_phone, info, sizeof(*info)); 
 	if (rc != EOK) {
 		async_wait_for(req, NULL);
Index: uspace/srv/devmap/devmap.c
===================================================================
--- uspace/srv/devmap/devmap.c	(revision 5c786d177c5354b44d4e3fa8f52182f680d515c1)
+++ uspace/srv/devmap/devmap.c	(revision 654b7dbfd1ebbe9e1b89c799d0698fa6cc06de69)
@@ -203,5 +203,5 @@
 	 * Get driver name
 	 */
-	if (!ipc_data_receive(&callid, NULL, &name_size)) {
+	if (!ipc_data_write_receive(&callid, NULL, &name_size)) {
 		printf("Unexpected request.\n");
 		free(driver);
@@ -234,5 +234,5 @@
 	 * Send confirmation to sender and get data into buffer.
 	 */
-	if (EOK != ipc_data_deliver(callid, driver->name, name_size)) {
+	if (EOK != ipc_data_write_deliver(callid, driver->name, name_size)) {
 		printf("Cannot read driver name.\n");
 		free(driver->name);
@@ -369,5 +369,5 @@
 	
 	/* Get device name */
-	if (!ipc_data_receive(&callid, NULL, &size)) {
+	if (!ipc_data_write_receive(&callid, NULL, &size)) {
 		free(device);
 		printf("Cannot read device name.\n");
@@ -395,5 +395,5 @@
 	}
 	
-	ipc_data_deliver(callid, device->name, size);
+	ipc_data_write_deliver(callid, device->name, size);
 	device->name[size] = 0;
 
@@ -490,5 +490,5 @@
 	 * read the name itself until the buffer is allocated).
 	 */
-	if (!ipc_data_receive(&callid, NULL, &name_size)) {
+	if (!ipc_data_write_receive(&callid, NULL, &name_size)) {
 		ipc_answer_0(callid, EREFUSED);
 		ipc_answer_0(iid, EREFUSED);
@@ -514,5 +514,5 @@
 	 * Send confirmation to sender and get data into buffer.
 	 */
-	if (EOK != (retval = ipc_data_deliver(callid, name, name_size))) {
+	if (EOK != (retval = ipc_data_write_deliver(callid, name, name_size))) {
 		ipc_answer_0(iid, EREFUSED);
 		return;
@@ -567,5 +567,5 @@
 	sending must be initiated by client
 
-	int rc = ipc_data_send(phone, device->name, name_size); 
+	int rc = ipc_data_write_send(phone, device->name, name_size); 
 	if (rc != EOK) {
 		async_wait_for(req, NULL);
Index: uspace/srv/vfs/vfs_mount.c
===================================================================
--- uspace/srv/vfs/vfs_mount.c	(revision 5c786d177c5354b44d4e3fa8f52182f680d515c1)
+++ uspace/srv/vfs/vfs_mount.c	(revision 654b7dbfd1ebbe9e1b89c799d0698fa6cc06de69)
@@ -87,5 +87,5 @@
 	 * system.
 	 */
-	if (!ipc_data_receive(&callid, NULL, &size)) {
+	if (!ipc_data_write_receive(&callid, NULL, &size)) {
 		ipc_answer_0(callid, EINVAL);
 		ipc_answer_0(rid, EINVAL);
@@ -107,5 +107,5 @@
 	 */
 	char fs_name[FS_NAME_MAXLEN + 1];
-	(void) ipc_data_deliver(callid, fs_name, size);
+	(void) ipc_data_write_deliver(callid, fs_name, size);
 	fs_name[size] = '\0';
 	
@@ -123,5 +123,5 @@
 	 * Now, we want the client to send us the mount point.
 	 */
-	if (!ipc_data_receive(&callid, NULL, &size)) {
+	if (!ipc_data_write_receive(&callid, NULL, &size)) {
 		ipc_answer_0(callid, EINVAL);
 		ipc_answer_0(rid, EINVAL);
@@ -151,5 +151,5 @@
 	 * Deliver the mount point.
 	 */
-	(void) ipc_data_deliver(callid, buf, size);
+	(void) ipc_data_write_deliver(callid, buf, size);
 
 	/*
Index: uspace/srv/vfs/vfs_open.c
===================================================================
--- uspace/srv/vfs/vfs_open.c	(revision 5c786d177c5354b44d4e3fa8f52182f680d515c1)
+++ uspace/srv/vfs/vfs_open.c	(revision 654b7dbfd1ebbe9e1b89c799d0698fa6cc06de69)
@@ -62,5 +62,5 @@
 	ipc_callid_t callid;
 
-	if (!ipc_data_receive(&callid, NULL, &size)) {
+	if (!ipc_data_write_receive(&callid, NULL, &size)) {
 		ipc_answer_0(callid, EINVAL);
 		ipc_answer_0(rid, EINVAL);
@@ -83,5 +83,5 @@
 
 	int rc;
-	if ((rc = ipc_data_deliver(callid, path, size))) {
+	if ((rc = ipc_data_write_deliver(callid, path, size))) {
 		ipc_answer_0(rid, rc);
 		free(path);
Index: uspace/srv/vfs/vfs_register.c
===================================================================
--- uspace/srv/vfs/vfs_register.c	(revision 5c786d177c5354b44d4e3fa8f52182f680d515c1)
+++ uspace/srv/vfs/vfs_register.c	(revision 654b7dbfd1ebbe9e1b89c799d0698fa6cc06de69)
@@ -165,5 +165,5 @@
 	 * VFS info structure from the client FS.
 	 */
-	if (!ipc_data_receive(&callid, NULL, &size)) {
+	if (!ipc_data_write_receive(&callid, NULL, &size)) {
 		/*
 		 * The client doesn't obey the same protocol as we do.
@@ -206,5 +206,5 @@
 	futex_initialize(&fs_info->phone_futex, 1);
 		
-	rc = ipc_data_deliver(callid, &fs_info->vfs_info, size);
+	rc = ipc_data_write_deliver(callid, &fs_info->vfs_info, size);
 	if (rc != EOK) {
 		dprintf("Failed to deliver the VFS info into our AS, rc=%d.\n",